from time import time
from transformers import TextIteratorStreamer

class BaseChatLLM:
	async def get_session_key(self):
		return self.model_id + ':messages'

	async def get_session_messages(self, request):
		f = get_serverenv('get_session')
		session = await f(request)
		key = self.get_session_key()
		messages = session.get(key) or []
		return messages

	async def set_session_messages(self, request, messages):
		f = get_serverenv('get_session')
		session = await f(request)
		key = self.get_session_key()
		session[key] = messages

	def get_streamer(self):
		return TextIteratorStreamer(
			tokenizer=self.tokenizer,
			skip_special_tokens=True,
			skip_prompt=True
		)

	def output_generator(self, streamer):
		all_txt = ''
		t1 = time()
		i = 0
		for txt in streamer:
			if i == 0:
				t2 = time()
			i += 1
			yield {
				'done': False,
				'text': txt
			}
		t3 = time()
		unk = self.tokenizer(all_txt, return_tensors="pt")
		print(f'{unk=};')
		output_tokens = len(unk["input_ids"][0])
		yield {
			'done': True,
			'text': '',
			'response_time': t2 - t1,
			'finish_time': t3 - t1,
			'output_token': output_tokens
		}
		
